/// <reference types="mocha" />
export declare type PluginBuilder<I, A1 = undefined, A2 = undefined, A3 = undefined, A4 = undefined> = (arg1?: A1, arg2?: A2, arg3?: A3, arg4?: A4) => Plugin<I>;
export interface Plugin<I> {
    run?(context: I): any;
    init?(context: I): any;
    finally?(context: I): any;
    catch?(context: I): any;
}
export interface Context {
    test: (typeof it | typeof it.skip);
    plugins: {
        [k: string]: PluginBuilder<any, any, any, any, any>;
    };
    expectation?: string;
    chain: Plugin<any>[];
    error?: Error & {
        code?: string;
    };
}
export interface Plugins {
    [k: string]: [object, any, any, any, any];
}
export interface It<I> {
    (expectation: string, cb?: (context: I) => any): void;
    (cb?: (context: I) => any): void;
}
export declare type Fancy<I extends Context, T extends Plugins> = {
    it: It<I>;
    end: It<I>;
    add<K extends string, O>(key: K, cb: (context: I) => Promise<O> | O): Fancy<I & {
        [P in K]: O;
    }, T>;
    do(cb: (context: I) => any): Fancy<I, T>;
    register<K extends string, O, A1, A2, A3, A4>(key: K, plugin: (arg1?: A1, arg2?: A2, arg3?: A3, arg4?: A4) => Plugin<O & I>): Fancy<I, T & {
        [P in K]: [O, A1, A2, A3, A4];
    }>;
} & {
    [P in keyof T]: (arg1?: T[P][1], arg2?: T[P][2], arg3?: T[P][3], arg4?: T[P][4]) => Fancy<T[P][0] & I, T>;
};
declare const _default: Fancy<Context, {
    skip: [{}, {}, {}, {}, {}];
} & {
    only: [{}, {}, {}, {}, {}];
}>;
export default _default;
