"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mock = require("stdout-stderr");
const create = (std) => (opts = {}) => ({
    run(ctx) {
        mock[std].start();
        mock[std].print = opts.print === true;
        mock[std].stripColor = opts.stripColor !== false;
        Object.defineProperty(ctx, std, {
            get: () => mock[std].output
        });
    },
    finally() {
        mock[std].stop();
    },
});
exports.stdout = create('stdout');
exports.stderr = create('stderr');
//# sourceMappingURL=stdmock.js.map